function hFigPrediction = ProMPs_plot_prediction(datasetsTest, lTestId, y_predProMPs, sigma_starProMPs, ...
    lambdaProMPs, T, DOF, usedSampleIds, y_testMat, y_predProMPsMat, hFigPredictionIn)

lw = 2;
fs = 26;
fsLegend=18;

datasetsTestTmp = datasetsTest(lTestId);
y_predVarProMPs = zeros(size(y_predProMPs));

if nargin < 11
    for i=1:DOF   
        hFigPrediction(i) = figure('Position',[2898, 410, 560, 420]);
        set(hFigPrediction(i),'Color','white');
    end
else
    hFigPrediction = hFigPredictionIn;
end

for t=1:size(y_predProMPs,1)
    y_predVarProMPs(t,:) =  datasetsTestTmp.PSI_X(t,:)*sigma_starProMPs*datasetsTestTmp.PSI_X(t,:)' + lambdaProMPs;
end
y_predVarProMPsMat = reshape(y_predVarProMPs,DOF,T);
timeIds = 1:T; %linspace(0,1,T);
for i=1:DOF   
    figure( hFigPrediction(i) );
    hold all;
    
    lndPred =  shadedErrorBar(timeIds,y_predProMPsMat(i,:),2*sqrt(y_predVarProMPsMat(i,:)),'b',1);
    est_plot = lndPred.mainLine;
    set(est_plot, 'linewidth', lw);
    hTrue=plot(timeIds, datasetsTestTmp.Ymat(i,:), 'k--', 'linewidth', lw);
    hObs=scatter(timeIds(usedSampleIds)', y_testMat(i,:)',100, '+k', 'linewidth',lw);
           
    xlabel('movement phase', 'fontsize', fs);
    ylabel(['prediction of joint ' num2str(i)] , 'fontsize', fs);
    
    lhndLegend=legend([est_plot, hTrue, hObs], 'prediction', 'true', 'observation');
    set(lhndLegend, 'fontsize',12);
    set(gca, 'fontsize', fs);
    axis tight;
end
